function f = binfact(a)

// f = binfact(a), Max-plus algebra binary factorization
// 
// This function convert decimal to binary. Binary is represented as vector
// where it's element represent location of nonzero.
//
// See also 
// otimes, oplus, aplus, maxplusscg, maxcircuit, maxalgol, maxalgolpa, maxalgolepa, iseigvec
// 
// Max-Plus Algebra Toolbox, ver. 1.0 July, 2007
// Copyright (C) Subiono, July, 2007


// Output variables initialisation (not found in input variables)
f = [];

// Display mode
mode(0);

// Display warning for floating point exception
ieee(1);

if a <= 0
   error('binfact: input must be positive integer');
end

i = 0;
while a > 0
   if modulo(a,2) == 1
      f = [f i];
      a = (a - 1)/2;
   else
      a = a / 2;
   end
   i = i + 1;
end


endfunction
