function [node_tree,id_parent_tran] = buildtree( ...
  forward,backward,new_node,id_parent,id_tran, ...
  node_tree,id_parent_tran)
  // fungsi rekursif ini digunakan untuk membangun
  // coverability tree yang direpresentasikan dalam
  // 2 variabel, yaitu:
  // node_tree : matriks yang kolomnya menyatakan node
  // id_parent_tran : matriks dengan 2 baris
  // baris 1 => id_parent dan baris 2 => id_transisi

  // bagian ini digunakan untuk menentukan node yang
  // didominasi dan memberikan nilai omega pada indeks
  // yang didominasi
  id_node = id_parent;
  while id_node ~= 0
    node = node_tree(:,id_node);
    ind = isdominate(new_node,node);
    new_node(ind) = %inf;
    id_node = id_parent_tran(1,id_node);
  end
  // update tree kecuali state
  new_data = [id_parent;id_tran];
  id_parent_tran = [id_parent_tran new_data];
  id_new_node = size(id_parent_tran,2);

  // duplicate node
  if node_tree ~= []
    if vectorfind(node_tree,new_node,'c') ~= []
      // node ini adalah duplicate
      node_tree = [node_tree new_node];
      return;
    end
  end

  // update state tree
  node_tree = [node_tree new_node];

  // cari enabled
  id_enabled = findenabled(backward,new_node);

  // fungsi ini dijalankan untuk setiap transisi enabled
  for i = 1:length(id_enabled)
    child_st = new_node + forward(:,id_enabled(i)) - ...
      backward(:,id_enabled(i));
    [node_tree,id_parent_tran] = buildtree(forward, ...
      backward,child_st,id_new_node,id_enabled(i), ...
      node_tree,id_parent_tran);
  end
endfunction