function intersectionguiext
  // simulasi jumlah pengguna berbasis GUI
  // kedatangan berdistribusi uniform
  // menginputkan jumlah jalur dan lama simulasi
  [jwb,jmljalur,waktusim] = getvalue( ...
    'Traffic lights simulation in intersection', ...
    ['Number of lanes';'Simulation time'], ...
    list('vec',1,'vec',1), ['2';'100']);
  // jika ditekan cancel, maka keluar dari program
  if jwb == %f
    messagebox('Exit from intersectionguiext','Information','info','OK','modal');
    return;
  end

  // inisialisasi input
  initpengguna = ones(10,1).*.[10];
  initmean = ones(10,1).*.[4];
  initvar = ones(10,1).*.[2];
  initmax = ones(10,1).*.[4];

  // inisialisasi
  data1 = zeros(jmljalur,1);
  data2 = zeros(jmljalur,1);
  data3 = zeros(jmljalur,1);
  data4 = zeros(jmljalur,1);
  data5 = zeros(jmljalur,1);
  data6 = zeros(jmljalur,1);
  data7 = zeros(jmljalur,1);
  data8 = zeros(jmljalur,1);

  for i = 1:floor(jmljalur/10)
    strjudul = 'Enter information for lanes ' + ...
      string((i-1)*10+1) + ' - ' + string(i*10) + ...
      ' of ' + string(jmljalur);
    // menginputkan 10 jalur
    [jwb,data1s,data2s,data3s,data4s,data5s,data6s, ...
      data7s,data8s] = getvalue(strjudul, ...
      ['Initial condition';'Maximum arrival'; ...
      'Mean departure when green'; ...
      'Variance departure when green'; ...
      'Maximum green turn on'; ...
      'Mean departure when yellow'; ...
      'Variance departure when yellow'; ...
      'Maximum yellow turn on'], ...
      list('col',10,'col',10,'col',10,'col',10, ...
      'col',10,'col',10,'col',10,'col',10), ...
      [strcat(string(initpengguna),';'); ...
      strcat(string(initmax),';'); ...
      strcat(string(jmljalur*initmean),';'); ...
      strcat(string(jmljalur*initvar),';'); ...
      strcat(string(jmljalur*initmax),';'); ...
      strcat(string(2*initmean),';'); ...
      strcat(string(2*initvar),';'); ...
      strcat(string(initmax),';')]);

    // jika ditekan cancel maka keluar dari program
    if jwb == %f
      messagebox('Exit from intersectionguiext','Information','info','OK','modal');
      return;
    end

    // menyimpan data yang diinputkan
    data1((i-1)*10+1:i*10) = data1s;
    data2((i-1)*10+1:i*10) = data2s;
    data3((i-1)*10+1:i*10) = data3s;
    data4((i-1)*10+1:i*10) = data4s;
    data5((i-1)*10+1:i*10) = data5s;
    data6((i-1)*10+1:i*10) = data6s;
    data7((i-1)*10+1:i*10) = data7s;
    data8((i-1)*10+1:i*10) = data8s;
  end

  // memproses sisanya jika ada
  if modulo(jmljalur,10) ~= 0
    // menyesuaikan ukuran matriks
    // menjadi lebih kecil dari sebelumnya
    initpengguna = ones(modulo(jmljalur,10),1).*.[10];
    initmean = ones(modulo(jmljalur,10),1).*.[4];
    initvar = ones(modulo(jmljalur,10),1).*.[2];
    initmax = ones(modulo(jmljalur,10),1).*.[4];
    // judul dialog
    strjudul = 'Enter information for lanes ' + ...
      string(jmljalur-modulo(jmljalur,10)+1) + ...
      ' - ' + string(jmljalur) + ' of ' + ...
      string(jmljalur);
    // menginputkan jalur sisanya
    [jwb,data1s,data2s,data3s,data4s,data5s,data6s, ...
      data7s,data8s] = getvalue(strjudul, ...
      ['Initial condition';'Maximum arrival'; ...
      'Mean departure when green'; ...
      'Variance departure when green'; ...
      'Maximum green turn on'; ...
      'Mean departure when yellow'; ...
      'Variance departure when yellow'; ...
      'Maximum yellow turn on'], ...
      list('col',modulo(jmljalur,10),'col', ...
      modulo(jmljalur,10),'col',modulo(jmljalur,10), ...
      'col',modulo(jmljalur,10),'col', ...
      modulo(jmljalur,10),'col',modulo(jmljalur,10), ...
      'col',modulo(jmljalur,10),'col', ...
      modulo(jmljalur,10)), ...
      [strcat(string(initpengguna),';'); ...
      strcat(string(initmax),';'); ...
      strcat(string(jmljalur*initmean),';'); ...
      strcat(string(jmljalur*initvar),';'); ...
      strcat(string(jmljalur*initmax),';'); ...
      strcat(string(2*initmean),';'); ...
      strcat(string(2*initvar),';'); ...
      strcat(string(initmax),';')]);

    // jika ditekan cancel maka keluar dari program
    if jwb == %f
      // menampilkan pesan
      messagebox('Exit from intersectionguiext','Information','info','OK','modal');
      return;
    end
    // menyimpan data yang diinputkan
    data1(jmljalur-modulo(jmljalur,10)+1:jmljalur) = ...
      data1s;
    data2(jmljalur-modulo(jmljalur,10)+1:jmljalur) = ...
      data2s;
    data3(jmljalur-modulo(jmljalur,10)+1:jmljalur) = ...
      data3s;
    data4(jmljalur-modulo(jmljalur,10)+1:jmljalur) = ...
      data4s;
    data5(jmljalur-modulo(jmljalur,10)+1:jmljalur) = ...
      data5s;
    data6(jmljalur-modulo(jmljalur,10)+1:jmljalur) = ...
      data6s;
    data7(jmljalur-modulo(jmljalur,10)+1:jmljalur) = ...
      data7s;
    data8(jmljalur-modulo(jmljalur,10)+1:jmljalur) = ...
      data8s;
  end

  // agar enak diinputkan
  data = [data1 data3 data6 data4 data7 data5 data8 ...
    data2];

  // memanggil prosedur untuk mensimulasikan
  pengguna = intersectionext(data,waktusim);

  // menampilkan grafik
  plot(pengguna');
  // judul grafik
  title('Traffic lights simulation in intersection');
  // label sumbu x dan sumbu y
  xlabel('Time');
  ylabel('Number of vehicles');
  // menampilkan keterangan tiap grafik
  legend('Lane ' + string(1:jmljalur)');
endfunction
