// *** SCIGUI V 2.1 AUTO-GENERATED FILE ***
// *** DO NOT EDIT BUT SPECIFIED ENTRY-POINTS ***

// MAIN FUNCTION
function lightsguiext(data,waktusim,indlampu)
  // Fungsi ini melakukan simulasi lampu lalulintas
  // data : matriks input (intersectionext.sci)
  // waktusim : lama simulasi dilakukan
  // indlampu : indeks lampu lalulintas yang ditampilkan

  // INIT-PRE-BEGIN
  timestep = 1000;
  jmllampu = length(indlampu);
  if jmllampu > 28
    messagebox(['Number of traffic lights' ...
      'cannot exceeds 28'],'Error','error','OK','modal');
    return;
  end

  // menghitung besar dialog
  scrwidth = 1024;
  scrheight = 768;
  // Scilab 5.x: ditambahi 10 agar lebih bagus
  dlgwidth = min(jmllampu,14)*70 + 10 + 10;
  // Scilab 5.x: perlu digeser ke bawah sejauh 130
  dlgheight = ceil(jmllampu/14)*240 + 10 + 130;
  // INIT-PRE-END

  // MAIN GUI
  hfig = figure( ...
    'BackgroundColor', [0.745098 0.745098 0.745098], ...
    'Position', [ceil((scrwidth-dlgwidth)/2) ...
    ceil((scrheight-dlgheight)/2) dlgwidth dlgheight]);

  // Create objects
  hobj = [];

  for i = 1:ceil(jmllampu/14)
    for j = 1:min(jmllampu - (i - 1)*14,14)

      // FRAME: tempat lampu lalulintas
      hobj6 = uicontrol(hfig, ...
        'Style', 'frame', ...
        'BackgroundColor', [0 0 0], ...
        'Position', [10+(j-1)*70 40+(i-1)*240 60 170]);
      // LABEL: tulisan di bawah lampu lalulintas
      hobj5 = uicontrol(hfig, ...
        'Style', 'text', ...
        'String', ...
        string(data(indlampu((i - 1)*14 + j),1)), ...
        'HorizontalAlignment', 'center', ...
        'VerticalAlignment', 'middle', ...
        'FontAngle', 'normal', ...
        'FontSize', 24, ...
        'FontWeight', 'demi', ...
        'BackgroundColor', ...
        [0.745098 0.745098 0.745098], ...
        'ForegroundColor', ...
        [0.254902 0.254902 0.254902], ...
        'Position', [10+(j-1)*70 10+(i-1)*240 60 25]);

      // LABEL: lampu lalulintas hijau
      hobj4 = uicontrol(hfig, ...
        'Style', 'text', ...
        'String', '', ...
        'HorizontalAlignment', 'center', ...
        'VerticalAlignment', 'middle', ...
        'FontAngle', 'normal', ...
        'FontSize', 24, ...
        'FontWeight', 'demi', ...
        'BackgroundColor', [1 1 1], ...
        'ForegroundColor', [1 0 1], ...
        'Position', [15+(j-1)*70 45+(i-1)*240 50 50]);

      // LABEL: lampu lalulintas kuning
      hobj3 = uicontrol(hfig, ...
        'Style', 'text', ...
        'String', '', ...
        'HorizontalAlignment', 'center', ...
        'VerticalAlignment', 'middle', ...
        'FontAngle', 'normal', ...
        'FontSize', 24, ...
        'FontWeight', 'demi', ...
        'BackgroundColor', [1 1 1], ...
        'ForegroundColor', [0 0 1], ...
        'Position', [15+(j-1)*70 100+(i-1)*240 50 50]);

      // LABEL: lampu lalulintas merah
      hobj2 = uicontrol(hfig, ...
        'Style', 'text', ...
        'String', '', ...
        'HorizontalAlignment', 'center', ...
        'VerticalAlignment', 'middle', ...
        'FontAngle', 'normal', ...
        'FontSize', 24, ...
        'FontWeight', 'demi', ...
        'BackgroundColor', [1 1 1], ...
        'ForegroundColor', [0 1 1], ...
        'Position', [15+(j-1)*70 155+(i-1)*240 50 50]);

      // LABEL: tulisan di atas lampu lalulintas
      hobj1 = uicontrol(hfig, ...
        'Style', 'text', ...
        'String', string(indlampu((i - 1)*14 + j)), ...
        'HorizontalAlignment', 'center', ...
        'VerticalAlignment', 'middle', ...
        'FontAngle', 'normal', ...
        'FontSize', 24, ...
        'FontWeight', 'demi', ...
        'BackgroundColor', ...
        [0.745098 0.745098 0.745098], ...
        'ForegroundColor', [0 0 1], ...
        'Position', [10+(j-1)*70 215+(i-1)*240 60 25]);
        
      hobj_temp = [hobj1;hobj2;hobj3;hobj4;hobj5;hobj6];
      hobj = [hobj hobj_temp];
    end
  end
  // bagian sebelumnya digunakan untuk membentuk GUI
  // selanjutnya adalah proses simulasi
  // jumlah jalur, jumlah baris matriks data
  jmljalur = size(data,1);

  // lstlampu digunakan untuk mengantisipasi ketika
  // lampu lalulintas pada suatu jalur ditampilkan
  // lebih dari satu.
  lstlampu = list();
  for i = 1:jmljalur
    lstlampu($+1) = find(indlampu == i)
  end

  // inisialisasi proses simulasi
  pengguna = data(:,1);
  t = 1;
  jlr = 0; // jalur yang dilayani, indeks dikurangi satu

  // tahap inisialisasi simulasi persimpangan
  tampil = zeros(jmljalur,1);
  lama = zeros(jmljalur,2); // 1 = hijau, 2 = kuning
  for i = 1:jmljalur
    xpre = pengguna(i) + data(i,8)*sum(lama(1:i-1,:))/2;
    lama(i,1) = min(max(ceil(xpre/data(i,2)),1), ...
      data(i,6));
    xpre = xpre + (data(i,8)/2 - data(i,2))*lama(i,1);
    lama(i,2) = min(max(ceil(xpre/data(i,3)),1), ...
      data(i,7));
    tampil(i) = sum(lama(1:i-1,:))
  end
  tampil(1) = lama(1,1);

  // inisialisasi tampilan
  // lama lampu lalulintas hijau menyala di jalur 1
  for i = lstlampu(1)
    set(hobj(4,i), 'BackgroundColor', [0 1 0]);
    set(hobj(4,i), 'String', string(tampil(1)));
  end
  // lama lampu lalulintas merah menyala di jalur lain
  for i = 2:jmljalur
    for j = lstlampu(i)
      set(hobj(2,j), 'BackgroundColor', [1 0 0]);
      set(hobj(2,j), 'String', string(tampil(i)));
    end
  end

  // waitbar
  wb = waitbar(0,'Simulation process');

  // proses simulasi
  while t < waktusim
    // simulasi hijau menyala
    for i = 1:lama(jlr+1,1)
      sleep(timestep);
      waitbar(min(t/waktusim,1),wb);
      // update variabel
      for j = 1:jmljalur
        pengguna(j) = max(pengguna(j) + ...
          grand(1,1,'uin',0,data(j,8)),0);
      end
      pengguna(jlr+1) = max(pengguna(jlr+1) - ...
        data(jlr+1,2) - round(sqrt(data(jlr+1,4))* ...
        rand(1,1,'normal')),0);
      t = t + 1;

      // update tampilan
      // lampu lalulintas merah di jalur yang lain
      tampil = tampil - 1;
      ind = [1:jlr jlr+2:jmljalur];
      for j = ind;
        for k = lstlampu(j)
          set(hobj(2,k), 'String', string(tampil(j)));
        end
      end
      // lampu lalulintas hijau
      for k = lstlampu(jlr+1)
        set(hobj(4,k), 'String', string(tampil(jlr+1)));
      end
      // pengguna
      for j = 1:jmljalur
        for k = lstlampu(j)
          set(hobj(5,k), 'String', string(pengguna(j)));
        end
      end
    end
    // proses pergantian
    // update variabel
    tampil(jlr+1) = lama(jlr+1,2);
    // update tampilan
    for k = lstlampu(jlr+1)
      // memadamkan lampu lalulintas hijau
      set(hobj(4,k), 'String', '');
      set(hobj(4,k), 'BackgroundColor', [1 1 1]);
      // menyalakan lampu lalulintas kuning
      set(hobj(3,k), 'BackgroundColor', [1 1 0]);
      set(hobj(3,k), 'String', string(tampil(jlr+1)));
    end
    // simulasi kuning menyala
    for i = 1:lama(jlr+1,2)
      sleep(timestep);
      waitbar(min(t/waktusim,1),wb);
      // update variabel
      for j = 1:jmljalur
        pengguna(j) = max(pengguna(j) + ...
          grand(1,1,'uin',0,data(j,8)),0);
      end
      pengguna(jlr+1) = max(pengguna(jlr+1) - ...
        data(jlr+1,3) - round(sqrt(data(jlr+1,5))* ...
        rand(1,1,'normal')),0);
      t = t + 1;
      // update tampilan
      // lampu lalulintas merah di jalur yang lain
      tampil = tampil - 1;
      ind = [1:jlr jlr+2:jmljalur];
      for j = ind
        for k = lstlampu(j)
          set(hobj(2,k), 'String', string(tampil(j)));
        end
      end

      // lampu lalulintas hijau
      for k = lstlampu(jlr+1)
        set(hobj(3,k), 'String', string(tampil(jlr+1)));
      end

      // pengguna
      for j = 1:jmljalur
        for k = lstlampu(j)
          set(hobj(5,k), 'String', string(pengguna(j)));
        end
      end
    end

    // proses pergantian
    // update variabel
    lama(jlr+1,:) = 0;
    tampil(jlr+1) = sum(lama);
    // menghitung lama lampu lalulintas hijau dan kuning
    // menyala pada periode berikutnya
    xpre = pengguna(jlr+1) + data(jlr+1,8)*sum(lama)/2;
    lama(jlr+1,1) = min(max(ceil(xpre/ ...
      data(jlr+1,2)),1),data(jlr+1,6));
    xpre = xpre + (data(jlr+1,8)/2 - data(jlr+1,2))* ...
      lama(jlr+1,1);
    lama(jlr+1,2) = min(max(ceil(xpre/ ...
      data(jlr+1,3)),1),data(jlr+1,7));
    // update tampilan
    for k = lstlampu(jlr+1)
      // memadamkan lampu lalulintas kuning
      set(hobj(3,k), 'String', '');
      set(hobj(3,k), 'BackgroundColor', [1 1 1]);
      // menyalakan lampu lalulintas merah
      set(hobj(2,k), 'BackgroundColor', [1 0 0]);
      set(hobj(2,k), 'String', string(tampil(jlr+1)));
    end

    // mengubah jalur yang hijau atau kuning
    jlr = modulo(jlr + 1,jmljalur);
    tampil(jlr+1) = lama(jlr+1,1);
    for k = lstlampu(jlr+1)
      // memadamkan lampu lalulintas merah
      set(hobj(2,k), 'String', '');
      set(hobj(2,k), 'BackgroundColor', [1 1 1]);
      // menyalakan lampu lalulintas hijau
      set(hobj(4,k), 'BackgroundColor', [0 1 0]);
      set(hobj(4,k), 'String', string(tampil(jlr+1)));
    end
  end

  sleep(timestep);
  waitbar(min(t/waktusim,1),wb);
  winclose(wb);
endfunction
