function lightsimulationext
  // fungsi ini melakukan simulasi lampu lalulintas
  // dengan kedatangan berdistribusi uniform
  // yang berbasis GUI

  // menginputkan jumlah jalur dan lama simulasi
  [jwb,jmljalur,waktusim] = getvalue('Traffic lights ...
simulation in intersection',['Number of lanes'; ...
    'Simulation time'], list('vec',1,'vec',1), ...
    ['4';'100']);

  // jika ditekan cancel, maka keluar dari program
  if jwb == %f
    messagebox('Exit from lightsimulationext','Information','info','OK','modal');
    return;
  end

  // inisialisasi input
  initpengguna = ones(10,1).*.[10];
  initmean = ones(10,1).*.[4];
  initvar = ones(10,1).*.[2];
  initmax = ones(10,1).*.[4];
  // inisialisasi
  data1 = zeros(jmljalur,1);
  data2 = zeros(jmljalur,1);
  data3 = zeros(jmljalur,1);
  data4 = zeros(jmljalur,1);
  data5 = zeros(jmljalur,1);
  data6 = zeros(jmljalur,1);
  data7 = zeros(jmljalur,1);
  data8 = zeros(jmljalur,1);

  // pada setiap iterasi, jalur yang diinputkan
  // sebanyak 10
  for i = 1:floor(jmljalur/10)
    strjudul = 'Enter information for lanes ' + ...
      string((i-1)*10+1) + ' - ' + string(i*10) + ...
      ' of ' + string(jmljalur);
    // menginputkan data pada setiap jalur
    [jwb,data1s,data2s,data3s,data4s,data5s,data6s, ...
      data7s,data8s] = getvalue(strjudul, ...
      ['Initial condition';'Maximum arrival'; ...
      'Mean departure when green'; ...
      'Variance departure when green'; ...
      'Maximum green turn on'; ...
      'Mean departure when yellow'; ...
      'Variance departure when yellow'; ...
      'Maximum yellow turn on'], ...
      list('col',10,'col',10,'col',10,'col',10, ...
      'col',10,'col',10,'col',10,'col',10), ...
      [strcat(string(initpengguna),';'); ...
      strcat(string(initmax),';'); ...
      strcat(string(jmljalur*initmean),';'); ...
      strcat(string(jmljalur*initvar),';'); ...
      strcat(string(jmljalur*initmax),';'); ...
      strcat(string(2*initmean),';'); ...
      strcat(string(2*initvar),';'); ...
      strcat(string(initmax),';')]);
    // jika ditekan cancel maka keluar dari program
    if jwb == %f
      messagebox('Exit from lightsimulationext','Information','info','OK','modal');
      return;
    end

    // menyimpan data yang diinputkan
    data1((i-1)*10+1:i*10) = data1s;
    data2((i-1)*10+1:i*10) = data2s;
    data3((i-1)*10+1:i*10) = data3s;
    data4((i-1)*10+1:i*10) = data4s;
    data5((i-1)*10+1:i*10) = data5s;
    data6((i-1)*10+1:i*10) = data6s;
    data7((i-1)*10+1:i*10) = data7s;
    data8((i-1)*10+1:i*10) = data8s;
  end

  // memproses sisanya jika ada
  if modulo(jmljalur,10) ~= 0
    // menyesuaikan ukuran matriks
    // menjadi lebih kecil dari sebelumnya
    initpengguna = ones(modulo(jmljalur,10),1).*.[10];
    initmean = ones(modulo(jmljalur,10),1).*.[4];
    initvar = ones(modulo(jmljalur,10),1).*.[2];
    initmax = ones(modulo(jmljalur,10),1).*.[4];
    // judul dialog
    strjudul = 'Enter information for lanes ' + ...
      string(jmljalur-modulo(jmljalur,10)+1) + ...
      ' - ' + string(jmljalur) + ' of ' + ...
      string(jmljalur);
    // menginputkan jalur sisanya
    [jwb,data1s,data2s,data3s,data4s,data5s,data6s, ...
      data7s,data8s] = getvalue(strjudul, ...
      ['Initial condition';'Maximum arrival'; ...
      'Mean departure when green'; ...
      'Variance departure when green'; ...
      'Maximum green turn on'; ...
      'Mean departure when yellow'; ...
      'Variance departure when yellow'; ...
      'Maximum yellow turn on'], ...
      list('col',modulo(jmljalur,10),'col', ...
      modulo(jmljalur,10),'col',modulo(jmljalur,10), ...
      'col',modulo(jmljalur,10),'col', ...
      modulo(jmljalur,10),'col',modulo(jmljalur,10), ...
      'col',modulo(jmljalur,10),'col', ...
      modulo(jmljalur,10)), ...
      [strcat(string(initpengguna),';'); ...
      strcat(string(initmax),';'); ...
      strcat(string(jmljalur*initmean),';'); ...
      strcat(string(jmljalur*initvar),';'); ...
      strcat(string(jmljalur*initmax),';'); ...
      strcat(string(2*initmean),';'); ...
      strcat(string(2*initvar),';'); ...
      strcat(string(initmax),';')]);

    // jika ditekan cancel maka keluar dari program
    if jwb == %f
      // menampilkan pesan
      messagebox('Exit from lightsimulationext','Information','info','OK','modal');
      return;
    end
    // menyimpan data yang diinputkan
    data1(jmljalur-modulo(jmljalur,10)+1:jmljalur) = ...
      data1s;
    data2(jmljalur-modulo(jmljalur,10)+1:jmljalur) = ...
      data2s;
    data3(jmljalur-modulo(jmljalur,10)+1:jmljalur) = ...
      data3s;
    data4(jmljalur-modulo(jmljalur,10)+1:jmljalur) = ...
      data4s;
    data5(jmljalur-modulo(jmljalur,10)+1:jmljalur) = ...
      data5s;
    data6(jmljalur-modulo(jmljalur,10)+1:jmljalur) = ...
      data6s;
    data7(jmljalur-modulo(jmljalur,10)+1:jmljalur) = ...
      data7s;
    data8(jmljalur-modulo(jmljalur,10)+1:jmljalur) = ...
      data8s;
  end
  // urutan menggunakan lightsguiext dan intersectionext
  data = [data1 data3 data6 data4 data7 data5 data8 ...
    data2];

  jmllampu = x_choose(string(1:28), ...
    ['How many lanes';'will be showed']);
  if jmllampu == 0
    messagebox('Exit from lightsimulationext','Information','info','OK','modal');
    return;
  end

  indlampu = zeros(1,jmllampu);
  for i = 1:floor(jmllampu/9)
    // menginputkan 9 data
    lst = list();
    for j = 1:9
      lst1 = list('Position ' + string((i-1)*9+j), ...
        modulo((i-1)*9+j-1,jmljalur) + 1, ...
        string(1:jmljalur));
      lst($+1) = lst1;
    end
    rep = x_choices(['Indices of lanes'; ...
      'will be showed'],lst);
    if rep == []
      messagebox('Exit from lightsimulationext','Information','info','OK','modal');
      return;
    end
    indlampu(1,(i-1)*9+1:i*9) = rep;
  end
  if modulo(jmllampu,9) ~= 0 // ada sisanya
    lst = list();
    for i = 1:modulo(jmllampu,9)
      lst1 = list('Position ' + ...
        string(jmllampu-i+1), ...
        modulo(jmllampu-i,jmljalur) + 1, ...
        string(1:jmljalur));
      lst(0) = lst1;
    end
    rep = x_choices(['Indices of lanes'; ...
      'will be showed'],lst);
    if rep == []
      messagebox('Exit from lightsimulationext','Information','info','OK','modal');
      return;
    end
    indlampu(1, ...
      jmllampu-modulo(jmllampu,9)+1:jmllampu) = rep;
  end
  // memanggil prosedur untuk mensimulasikan
  lightsguiext(data,waktusim,indlampu); 
endfunction
