function v = maxplusctv(A) 

// v = maxplusctv(A), maxplus algebra toolbox to compute  cycle time vector of  a square matrix.
// Function return to a vector v
// as a cycle time vector of matrix A.
// If all components of v are equals to the same value lam, then this lam is the eigenvalue of 
// matirx A.
// see also: 
// maxpluspwrbig, maxcircuit, maxalgol. 
//
// Max-Plus Algebra Toolbox, ver. 1.01 Jan, 2009
// Copyright (C) Subiono, Dec, 2008


mode(0);

ieee(1);

s=maxplusscg(A);

// check the matrix must be a square matrix.
na = size(A);
n=na(1);
if na(1) ~= na(2)
   error('maxplusctv : matrix is not square');
end;


An=maxpluspwr(A,n);
N=maxpluszeros(n,n);
ss=isequal(An,N);
if ss==%t;
 v=[" No any circuit of The Graph G(A) "];
 return;
end
//s=maxplusscg(A);
if s==%t;
  [l]=maxalgol(A);
   v=l*ones(na(1),1);
   return;
end
x0=zeros(na(1),1);
//s=maxpluscg(A);
np=10^300;
va=(1/2^ceil(log2(np)))*maxpluspwrbig(A,np);
v=maxplusotimes(va,x0);
//k=find(v == -%inf);
//if k~=[];
 // error('Cycle time vector must be finete')
//end
v=clean(v);

endfunction
