function  maxplusgantchart(X,t,R,xrange,ytick)

[%nargout,%nargin] = argn(0)


select %nargin 
    case 3
        [rsize, xsize] = checkVar(X, t, R);
        [xmin, xmax, ymin, ymax, yt] = setDef(X, t, rsize, xsize);        
        
    case 4
        [rsize, xsize] = checkVar(X, t, R);
        [xmin, xmax, ymin, ymax, yt] = setDef(X, t, rsize, xsize);
        
        rangesize = size(xrange);
        if (rangesize(1) == 1) & (rangesize(2) == 1)
            yt = xrange;
        elseif (rangesize(1) == 1) & (rangesize(2) == 2)
            xmin = xrange(1);
            xmax = xrange(2);
        else
            error('wrong parameters of axes range')
        end
        
    case 5
        [rsize, xsize] = checkVar(X, t, R);
        [xmin, xmax, ymin, ymax, yt] = setDef(X, t, rsize, xsize);
        
        rangesize = size(xrange);
        if (rangesize(1) == 1) & (rangesize(2) == 2)
            xmin = xrange(1);
            xmax = xrange(2);
        else
            error('wrong parameters of axes range')
        end
        
        yt = ytick;
end


X1 = ones(rsize(1),xsize(2),rsize(2)) * -%inf;

t1 = ones(rsize(1),rsize(2),xsize(2)) * -%inf;


tsize = size(t);
if tsize(2) == 1
    tt = t;
end


for i=1:rsize(1)
    for j=1:rsize(2)
        for k=1:xsize(2)
            if tsize(2) > 1
                tt = t(:,k);
            end
            if R(i,j) > 0
                t1(i,j,k) = tt(R(i,j));
            end
        end
    end
end


for i=1:rsize(1)
    for j=1:rsize(2)
        if R(i,j) > 0
           X1(i,:,j) = X(R(i,j),:);
        end
    end
end
x1size = size(X1);


//set(gca(),"grid",[1,1]);

for line=1:x1size(1)
   for j=1:x1size(2)
       for k=1:x1size(3)
           if(X1(line,j,k)>-%inf)
                  rects=[X1(line,j,k); line+1; t1(line,k,j); 0.9];
                  cols=[pmodulo(j,7)+1]; 
                  xrects(rects,cols);
           end
       end
   end
end
xgrid(1);
if yt == 1
   set(gca(),"grid",[1,ymax]);
end
mtlb_axis([xmin xmax ymin ymax]);
a=get("current_axes");
a.x_label;
a.y_label; 
xtitle("GantChart","time","resources");
endfunction

function [xmin, xmax, ymin, ymax, yt] = setDef(X,t,rsize,xsize)
xmin = min(X(:,1));

tsize = size(t);
if tsize(2)==1
    xmax = max(X(:,xsize(2))+t);
else
    xmax = max(X(:,xsize(2))+t(:,xsize(2)));
end

ymin = 1;
ymax = rsize(1)+1;
yt   = 1;
endfunction

function [rsize,xsize] = checkVar(X,t,R)
if isempty(X)
    error('a matrix of state vectors is empty!');
end
if isempty(t)
    error('a time vector is empty!');
end
if isempty(R)
    error('a matrix of resources-state-vector is empty!');
end
xsize = size(X);
tsize = size(t);
if xsize(1)~=tsize(1)
    error('inconsistent X and t sizes');
end
if ((tsize(2)~=1) & (tsize(2)~=xsize(2)))
    error('inconsistent X and t sizes');
end
rsize = size(R);
endfunction
