function s = maxplusscg(A) 

// s = maxplussscg(A), maxplus algebra check whether graph G(A) is strongly connected.
// Function return %T if the graph G(A) is strongly connected
// and return %F if the graph G(A) not strongly connected
// The matrix A must be a square matrix.
//
// see also: 
// otimes, oplus, aplus, maxpluspwr, maxcircuit, maxalgol, maxalgolpa, maxalgolepa, iseigvec

mode(0);

ieee(1);

 
// check input values

na = size(A);
if na(1) ~= na(2)
   error("maxplusscg: matrix is not square");
end;

s=%f;
B=A;
C=A;
for i=2:na(1)
    C=maxplusotimes(C,A);
    B=maxplusoplus(B,C);
end
//an=maxpluspwr(A,na(1));
k=find(B==-%inf);
if k==[];
s = %t;
end;
endfunction
