function mark = petrinetsimulation(forward,backward, ...
  mark,namaplace,namatran,capacity,priority)
  //disp(namaplace);
  // Ini adalah fungsi mensimulasikan petri net
  // yang berbasis GUI
  // Input fungsi ini adalah
  // 1. forward   : forward incidence berukuran pm x tn
  // 2. backward  : backward incidence berukuran pm x tn
  // 3. mark      : keadaan, vektor berukuran pm
  // 4. namaplace : vektor string berukuran pm
  // 5. namatran  : vektor string berukuran tn
  // keadaan yang dihasilkan adalah keadaan
  // yang terakhir sebelum keluar
  // menghitung jumlah place dan transisi
  [pm tn] = size(forward);
  // vektorplace digunakan untuk menampilkan
  // urutan place pada Petri net
  vektorplace = 'x = [' + strcat(namaplace,';') + ']';
  while 1
    // forward incidence
    ind = find(forward);
//    disp('fordward');
//    disp(forward);
//    disp('ind');
//    disp(ind);
    // apakah ada arc dari transisi ke place ?
    if ind ~= []
      jmlarc = length(ind);
      for i = 1:floor(jmlarc/30)
        indproses = ind((i-1)*30+1:i*30);
        // memproses 30 arc
        [place,tran] = ind2sub([pm,tn],indproses);
        strjudul = 'Forward incidence, arc ' + ...
          string((i-1)*30+1) + ' - ' + ...
          string(i*30) + ' of ' + string(jmlarc);
        jwb = x_mdialog(strjudul, ...
          namatran(tran) + ' => ' + ...
          namaplace(place),string(forward(indproses)));
        if jwb == []
          messagebox(['Exit from petrinetsimulation']);
          return;
        end
        jwb(find(jwb == '')) = '0';
        // mengupdate matriks forward incidence
        forward(indproses) = evstr(jwb);
      end
      if modulo(jmlarc,30) ~= 0
        indproses = ind( ...
          jmlarc-modulo(jmlarc,30)+1:jmlarc);
        // memproses arc sisanya
        [place,tran] = ind2sub([pm,tn],indproses);
        strjudul = 'Forward incidence, arc ' + ...
          string(jmlarc-modulo(jmlarc,30)+1) + ...
          ' - ' + string(jmlarc) + ' of ' + ...
          string(jmlarc);
        jwb = x_mdialog(strjudul, ...
          namatran(tran) + ' => ' + ...
          namaplace(place),string(forward(indproses)));
        if jwb == []
          messagebox(['Exit from petrinetsimulation']);
          return;
        end
        jwb(find(jwb == '')) = '0';
        forward(indproses) = evstr(jwb);
      end
    else
      messagebox(['There are no arc from transition ...
to place']);
    end

    // backward incidence
    ind = find(backward);
//    disp('backward');
//    disp(backward);
//    disp('ind');
//    disp(ind);
    // apakah ada arc dari place ke transisi ?
    if ind ~= []
      jmlarc = length(ind);
      for i = 1:floor(jmlarc/30)
        indproses = ind((i-1)*30+1:i*30);
        // memproses 30 arc
        [place,tran] = ind2sub([pm,tn],indproses);
        strjudul = 'Backward incidence, arc ' + ...
          string((i-1)*30+1) + ' - ' + ...
          string(i*30) + ' of ' + string(jmlarc);
        jwb = x_mdialog(strjudul, ...
          namaplace(place) + ' => ' + ...
          namatran(tran),string(backward(indproses)));
        // apakah tombol cancel ditekan ?
        if jwb == []
          messagebox(['Exit from petrinetsimulation']);
          return;
        end
        jwb(find(jwb == '')) = '0';
        // mengupdate matriks backward incidence
        backward(indproses) = evstr(jwb);
      end
      if modulo(jmlarc,30) ~= 0
        indproses = ind( ...
          jmlarc-modulo(jmlarc,30)+1:jmlarc);
        // memproses sisanya (kurang dari 30 arc)
        [place,tran] = ind2sub([pm,tn],indproses);
        strjudul = 'Backward incidence, arc ' + ...
          string(jmlarc-modulo(jmlarc,30)+1) + ...
          ' - ' + string(jmlarc) + ' of ' + ...
          string(jmlarc);
        jwb = x_mdialog(strjudul, ...
          namaplace(place) + ' => ' + ...
          namatran(tran),string(backward(indproses)));
        if jwb == []
          messagebox(['Exit from petrinetsimulation']);
          return;
        end
        jwb(find(jwb == '')) = '0';
        backward(indproses) = evstr(jwb);
      end
    else
      messagebox(['There are no arc from place ...
to transition']);
return;
end

    
    // state
    for i = 1:floor(pm/30)
      // memproses 30 marking
      strjudul = 'Marking, place ' + ...
        string((i-1)*30+1) + ' - ' + string(i*30) + ...
        ' of ' + string(pm);
      jwb = x_mdialog(strjudul,namaplace( ...
        (i-1)*30+1:i*30),string(mark((i-1)*30+1:i*30)));
      if jwb == []
        messagebox(['Exit from petrinetsimulation']);
        return;
      end
      jwb(find(jwb == '')) = '0';
      // mengupdate marking
      mark((i-1)*30+1:i*30) = evstr(jwb);
    end
    if modulo(pm,30) ~= 0
      // memproses sisanya (kurang dari 30 marking)
      strjudul = 'Marking, place ' + ...
        string(pm-modulo(pm,30)+1) + ' - ' + ...
        string(pm) + ' of ' + string(pm);
      jwb = x_mdialog(strjudul,namaplace( ...
        pm-modulo(pm,30)+1:pm),string(mark( ...
        pm-modulo(pm,30)+1:pm)));
      // apakah tombol cancel ditekan ?
      if jwb == []
        messagebox(['Exit from petrinetsimulation']);
        return;
      end
      jwb(find(jwb == '')) = '0';
      // mengupdate marking
      mark(pm-modulo(pm,30)+1:pm) = evstr(jwb);
    end
    
    
    
    
    
    //capacity
    capacitymodif=emptystr(pm,1);
    for i=1:pm
        if capacity(i)~=0 & capacity(i)~=%inf then
            capacitymodif(i)=string(capacity(i));
            capacitymodi(i)=capacity(i);
        else
            capacitymodif(i)='infinity';
            capacitymodi(i)=%inf;
        end
    end
    for i = 1:floor(pm/30)
      // memproses 30 marking
      strjudul = 'capacity, place ' + ...
        string((i-1)*30+1) + ' - ' + string(i*30) + ...
        ' of ' + string(pm);
        
      jwb = x_mdialog(strjudul,namaplace( ...
        (i-1)*30+1:i*30),capacitymodif((i-1)*30+1:i*30));
      if jwb == []
        messagebox(['Exit from petrinetsimulation']);
        return;
      end
      jwb(find(jwb == 'infinity')) = '%inf';
      jwb(find(jwb == '0')) = '%inf';
      jwb(find(jwb == '')) = '%inf';
      // mengupdate marking
      capacitymodi((i-1)*30+1:i*30) =evstr(jwb);
    end
    if modulo(pm,30) ~= 0
      // memproses sisanya (kurang dari 30 marking)
      strjudul = 'capacity, place ' + ...
        string(pm-modulo(pm,30)+1) + ' - ' + ...
        string(pm) + ' of ' + string(pm);
      jwb = x_mdialog(strjudul,namaplace( ...
        pm-modulo(pm,30)+1:pm),capacitymodif( ...
        pm-modulo(pm,30)+1:pm));
      // apakah tombol cancel ditekan ?
      if jwb == []
        messagebox(['Exit from petrinetsimulation']);
        return;
      end
      jwb(find(jwb == 'infinity')) = '%inf';
      jwb(find(jwb == '0')) = '%inf';
      jwb(find(jwb == '')) = '%inf';
      // mengupdate marking
      capacitymodi(pm-modulo(pm,30)+1:pm) =evstr(jwb);
    end
    capacity=capacitymodi;








    
    //priority
    for i = 1:floor(tn/30)
      // memproses 30 marking
      strjudul = 'priority, transition ' + ...
        string((i-1)*30+1) + ' - ' + string(i*30) + ...
        ' of ' + string(tn);
        
      jwb = x_mdialog(strjudul,namatran( ...
        (i-1)*30+1:i*30),string(priority((i-1)*30+1:i*30)));
      if jwb == []
        messagebox(['Exit from petrinetsimulation']);
        return;
      end
      jwb(find(jwb == '')) = '0';
      // mengupdate marking
      priority((i-1)*30+1:i*30) = evstr(jwb);
    end
    
    //disp(size(forward,1));
    //disp(size(priority));
    //disp(priority);
    if modulo(tn,30) ~= 0
      // memproses sisanya (kurang dari 30 marking)
      strjudul = 'priority, transition ' + ...
        string(tn-modulo(tn,30)+1) + ' - ' + ...
        string(tn) + ' of ' + string(tn);
      jwb = x_mdialog(strjudul,namatran( ...
        tn-modulo(tn,30)+1:tn),string(priority( ...
        tn-modulo(tn,30)+1:tn)));
      // apakah tombol cancel ditekan ?
      if jwb == []
        messagebox(['Exit from petrinetsimulation']);
        return;
      end
      jwb(find(jwb == '')) = '0';
      // mengupdate marking
      priority(tn-modulo(tn,30)+1:tn) = evstr(jwb);
    end











    // matriks insiden
    insiden = forward - backward;

    // urutan transisi yang difire sebelumnya
    //disp(mark)
    history = '0.' ;
    historyvek=mark;
    while 1
      // cari transisi yang enabled
      idenabled = findenabled(backward,mark);
      //disp(forward)
      //disp(mark)
      if idenabled ~= []
        // pilih transisi
        
        T=idenabled;
        T1=[];
        hitung=[];
        for i=1:length(T)
            hitung=forward(:,T(i));
            //disp(hitung)
            //disp(mark)
            if (hitung+mark)<=capacitymodi then
                T1=[T1;T(i)];
            end
        end
        if T1==[] then
            jwb2=messagebox(['Petri net marking is deadlock'; ...
              'Back to forward incidence dialog?'],"modal", "info", ["Yes" "No"]);
            if jwb2==1  then
                break;
            else
                return;
            end
        end
            
        pT=priority(T1');
        maks=max(pT);
        idenabled=find(pT==maks);
        idenabled=T1(idenabled);
        str = x_choose(namatran(idenabled), ...
          ['Choose transition to fire next']);
        if str == 0
            
          // tombol OK tidak ditekan
          jwb2=messagebox(['No transition is fired next'; ...
            'Back to forward incidence dialog?'],"modal", "info", ["Yes" "No"]);
          // keluar dari perulangan
          if jwb2==1 then
              break;
          else
              return;
          end
        end
        // pemfirean
        mark = mark + insiden(:,idenabled(str));

        // state setelah difire
        for i = 1:floor(pm/30)
          // memproses 30 marking
          strjudul = 'Marking, place ' + ...
            string((i-1)*30+1) + ' - ' + ...
            string(i*30) + ' of ' + string(pm);
          jwb = x_mdialog(strjudul, ...
            namaplace((i-1)*30+1:i*30), ...
            string(mark((i-1)*30+1:i*30)));
          // apakah tombol cancel ditekan ?
          if jwb == []
            messagebox(['Exit from petrinetsimulation']);
            return;
          end
          jwb(find(jwb == '')) = '0';
          // mengupdate marking
          mark((i-1)*30+1:i*30) = evstr(jwb);
        end
        if modulo(pm,30) ~= 0
          // memproses sisanya (kurang dari 30 marking)
          strjudul = 'Marking, place ' + ...
            string(pm-modulo(pm,30)+1) + ' - ' + ...
            string(pm) + ' of ' + string(pm);
          jwb = x_mdialog(strjudul,namaplace( ...
            pm-modulo(pm,30)+1:pm),string(mark( ...
            pm-modulo(pm,30)+1:pm)));
          if jwb == []
            messagebox(['Exit from petrinetsimulation']);
            return;
          end
          jwb(find(jwb == '')) = '0';
          mark(pm-modulo(pm,30)+1:pm) = evstr(jwb);
        end

        // menampilkan pemfirean sebelumnya
        
        
       newhistory = string(size(history,1)) + ...
          '. ' + namatran(idenabled(str));
        //newhistoryvek = mark;
        
        history = [history;newhistory];
        historyvek=[historyvek,mark];
        number_firing=30;
          a=['Place Name'];
          history1=[a;history];
          historyveks=string(historyvek);
          for i=1:size(historyveks,1)
              for j=1:size(historyveks,2)
                  historyveks(i,j)=namaplace(i)+' is  marked '+historyveks(i,j);
              end
          end
          historyvek1=[namaplace,historyveks];
        while 1  
            str = x_choose(history1, ...
                    ['Choose one of history to see vector or click ok for skip']);
            if str == 0
            
                // tombol OK tidak ditekan
                jwb2=messagebox(['No history is choosed'; ...
                'Next to firing?'],"modal", "info", ["Yes" "No"]);
                // keluar dari perulangan
                if jwb2==1 then
                    break;
                else
                    return;
                end
             end
             jwb2=messagebox(historyvek1(:,str),"modal", "info", ["Yes" "No"]);
             if jwb2==2  then
                return;
             end
             
        end
          
          
        
//        newhistory = string(size(history,1)) + ...
//          '. ' + namatran(idenabled(str)) + ' => ';
//        newhistory = newhistory + '[' + ...
//          strcat(string(mark),';') + ']';
//        history = [history;newhistory];
//        number_firing=30;
//          a=['Firing history'; ...
//          vektorplace];
//          history1=[a;history];
//          jwb2=messagebox(history1,"modal", "info", ["Yes" "No"]);
//          if jwb2==2  then
//              return;
//          end
      else
        // deadlock
        jwb2=messagebox(['Petri net marking is deadlock'; ...
          'Back to forward incidence dialog?'],"modal", "info", ["Yes" "No"]);
        if jwb2==1  then
            break;
        else
            return;
        end
      end
    end
  end
endfunction
