function [forward,backward,mark,namaplace,namatran,capacity,priority] ...
  = readpipe()
  // output fungsi ini adalah:
  // 1. forward[][]  => matriks insiden
  // 2. backward[][] => backward insiden
  // 3. mark[]       => kondisi awal place
  // 4. namaplace[]  => nama place pada Petri net
  // 5. namatran[]   => nama transisi pada Petri net
    
    // proses inti
    // memilih file xml yang dibuat dengan PIPE
    //jwb = tk_getfile('*.xml',Title='Choose Petri net');
    jwb = uigetfile('*.xml',Title='Choose Petri net');
    if jwb == ''
      // jika tidak ditekan OK
      // x_message(['Exit from pipesimulation']);
      disp('You exit from this process');
      return;
    end

  // inisialisasi
  namaplace = [];
  namatran = [];
  mark = [];
  // ID place
  place = [];
  // ID transisi
  tran = [];
  capacity=[];
  priority=[];

  // membuka file untuk dibaca
  fp = mopen(jwb,'r');
  // membaca file per kata
  str = mfscanf(fp,'%s');
  while str ~= 'net"">'
    str = mfscanf(fp,'%s');
  end
  str = mfscanf(fp,'%s');
  if str == '<tokenclass' | str == '<token' then
      while str ~= 'blue=""0""/>'
        str = mfscanf(fp,'%s');
      end
      str = mfscanf(fp,'%s');
  end
  // membaca place
  while str == '<place'
    // ID
    str = mfscanf(fp,'%s');
    str_simp=str;   
    str = strsplit(str,[4 length(str)-2]);
    while str(3) ~= '"">'
        str = mfscanf(fp,'%s');
        str_simp=str_simp+' '+str;
        //str_simp = strcat(str_simp,str);   
        str = strsplit(str_simp,[4 length(str_simp)-2]);
    end
    
    // menyimpan ID place
    place = [place;str(2)];
    // nama
    str = mfscanf(fp,'%s');
    while str ~= '<name>'
      str = mfscanf(fp,'%s');
    end
    str = mfscanf(fp,'%s');
    str_end = emptystr(2,1);
    if length(str) > 8
      str_end = strsplit(str,length(str)-8);
    end
    while str_end(2) ~= '</value>'
      str_end = mfscanf(fp,'%s');
      str_end=['';str_end];
      
      str=str+' ';
      str = strcat([str,str_end(2)]);
      if length(str_end(2)) > 8
        
        str_end=str_end(2);
        str_end = strsplit(str_end, ...
          length(str_end)-8);
      end
    end
    str = strsplit(str,[7 length(str)-8]);
    namaplace = [namaplace;str(2)];
    // marking
    str = mfscanf(fp,'%s');
    while str ~= '<initialMarking>'
      str = mfscanf(fp,'%s');
    end
    str1 = mfscanf(fp,'%s');
    str = strsplit(str1,[7 length(str1)-8]);
    strk=strsplit(str1,[7 length(str1)-8-(length(str(2))-8)]);
    if strk(2)=='Default,' then
        str = strsplit(str1,[15 length(str1)-8]);
    end
    mark = [mark;evstr(str(2))]
    //capacity
    str=mfscanf(fp,'%s');
    while str ~= '<capacity>'
      str = mfscanf(fp,'%s');
    end
    str1 = mfscanf(fp,'%s');
    str = strsplit(str1,[7 length(str1)-8]);
    capacity = [capacity;evstr(str(2))]
    // menuntaskan
    str = mfscanf(fp,'%s');
    while str ~= '</place>'
      str = mfscanf(fp,'%s');
    end
    str = mfscanf(fp,'%s');
  end
  // membaca transisi
  while str == '<transition'
    // ID
    
    str = mfscanf(fp,'%s');
    str_simp=str;   
    str = strsplit(str,[4 length(str)-2]);
    while str(3) ~= '"">'
        str = mfscanf(fp,'%s');
        str_simp=str_simp+' '+str;
        //str_simp = strcat(str_simp,str);   
        str = strsplit(str_simp,[4 length(str_simp)-2]);
    end
    
    
    tran = [tran;str(2)];
    
    // nama
    str = mfscanf(fp,'%s');
    while str ~= '<name>'
      str = mfscanf(fp,'%s');
    end
    str = mfscanf(fp,'%s');
    str_end = emptystr(2,1);
    if length(str) > 8
      str_end = strsplit(str,length(str)-8);
    end
    // apakah lebih dari 1 kata ?
    while str_end(2) ~= '</value>'
      str_end = ['';mfscanf(fp,'%s')];
      str=str+' ';
      str = strcat([str,str_end(2)]);
      if length(str_end(2)) > 8
        str_end = strsplit(str_end(2), ...
          length(str_end(2))-8);
      end
    end
    str = strsplit(str,[7 length(str)-8]);
    namatran = [namatran;str(2)];
    //priority
    str=mfscanf(fp,'%s');
    while str ~= '<priority>'
      str = mfscanf(fp,'%s');
    end
    str1 = mfscanf(fp,'%s');
    str = strsplit(str1,[7 length(str1)-8]);
    priority = [priority;evstr(str(2))]
    // menuntaskan
    str = mfscanf(fp,'%s');
    while str ~= '</transition>'
      str = mfscanf(fp,'%s');
    end
    str = mfscanf(fp,'%s');
  end
  // matriks insiden
  pm = size(namaplace,1); // jumlah place
  tn = size(namatran,1); // jumlah transisi
  forward = zeros(pm,tn);
  backward = zeros(pm,tn);

  while str == '<arc'
      while 1
          if  length(str)<7 then
              str = mfscanf(fp,'%s');
          else
              strk=' '+str+'  ';
              temp= strsplit(strk,[1 8]);
              if temp(2)=='source=' then
                  break;
              else
                  str = mfscanf(fp,'%s');
              end
          end
      end
    
    str_simp='';
    strk=' '+str+'        ';
    temp= strsplit(strk,[1 8]);
    while temp(2)~='target='
      str_simp=str_simp+' '+str;
      str = mfscanf(fp,'%s');
      strk=' '+str+'        ';
      temp= strsplit(strk,[1 8]);
    end
    str_temp=str;
    str=str_simp;

    strk=str+' ';
    str = strsplit(strk,[10 length(str)]-1);
    str2=str(2);
    src = strsplit(str2,1);
    //check place atau bukan
    check=find(tran == str(2));
    
   
    if check==[]
      // place -> transisi
      src = find(place == str(2));
      str=str(2);
      //str = mfscanf(fp,'%s');
      str_temp=' '+str_temp;
      str_simp=str_temp;
      
      str = strsplit(str_simp,[1 length(str_simp)-1]);
      while str(3)~='>'
          str = mfscanf(fp,'%s');
          str_simp=str_simp+' '+str;
          str = strsplit(str_simp,[1 length(str_simp)-1]);
      end
      str = strsplit(str_simp,[9 length(str_simp)-2]);

      des = find(tran == str(2));
      
      str = mfscanf(fp,'%s');
      while str ~= '<inscription>'
        str = mfscanf(fp,'%s');
      end
      str1 = mfscanf(fp,'%s');
      str = strsplit(str1,[7 length(str1)-8]);
      strk=strsplit(str1,[7 length(str1)-8-(length(str(2))-8)]);
      if strk(2)=='Default,' then
        str = strsplit(str1,[15 length(str1)-8]);
      end
      backward(src,des) = evstr(str(2));
    else
      // transisi -> place
      src = find(tran == str(2));
      str=str(2);
      //str = mfscanf(fp,'%s');
      str_temp=' '+str_temp;
      str_simp=str_temp;
      str = strsplit(str_simp,[1 length(str_simp)-1]);
      while str(3)~='>'
          str = mfscanf(fp,'%s');
          str_simp=str_simp+' '+str;
          str = strsplit(str_simp,[1 length(str_simp)-1]);
      end
      str = strsplit(str_simp,[9 length(str_simp)-2]);
      des = find(place == str(2));
      str = mfscanf(fp,'%s');
      while str ~= '<inscription>'
        str = mfscanf(fp,'%s');
      end
      str1 = mfscanf(fp,'%s');
      str = strsplit(str1,[7 length(str1)-8]);
      strk=strsplit(str1,[7 length(str1)-8-(length(str(2))-8)]);
      if strk(2)=='Default,' then
        str = strsplit(str1,[15 length(str1)-8]);
      end
      forward(des,src) = evstr(str(2));
    end

    // menuntaskan
    str = mfscanf(fp,'%s');
    while str ~= '</arc>'
      str = mfscanf(fp,'%s');
    end
    str = mfscanf(fp,'%s');
  end

  mclose(fp);
  clear str src des t fp place tran;
endfunction
