function [forward,backward,x0,np,nt] = ...
  tlintersection(th,tk)
  // fungsi ini digunakan untuk membuat
  // Petri net lampu lalulintas di persimpangan
  // dilengkapi dengan nama place dan
  // nama transisi
  // menghitung jumlah jalur
  l = length(th);

  // membangun matriks forward incidence
  forward = zeros(5*l,4*l);
  wkt = sum([th tk]) - sum([th tk],'c');
  // proses utama
  forward(20*l^2-4*l:20*l^2-4*l+1) = [wkt(l);th(1)]
  // iterasi for pertama
  forward(16*l+5:20*l+4:20*l^2-20*l-3) = th(2:l);
  forward(15*l+1:20*l+1:20*l^2-24*l-1) = wkt(1:l-1);
  // iterasi for kedua
  forward(l+1:20*l+4:20*l^2-15*l-3) = 1;
  forward(l+2:20*l+4:20*l^2-15*l-2) = 1;
  forward(11*l+3:20*l+4:20*l^2-5*l-1) = 1;
  forward(11*l+4:20*l+4:20*l^2-5*l) = 1;
  forward(6*l+3:20*l+4:20*l^2-10*l-1) = tk;

  // membangun matriks backward incidence
  backward = [ones(l,4*l);zeros(4*l,4*l)];
  // proses utama
  backward(l+1:20*l+4:20*l^2-15*l-3) = 2;
  backward(6*l+1:20*l+4:20*l^2-10*l-3) = 1;
  backward(11*l+3:20*l+4:20*l^2-5*l-1) = 2;
  backward(16*l+3:20*l+4:20*l^2-1) = 1;
  backward(6*l+2:20*l+4:20*l^2-10*l-2) = th - 1;
  backward(16*l+4:20*l+4:20*l^2) = tk - 1;
  backward(1:20*l+1:20*l^2-19*l) = 0;
  backward(5*l+1:20*l+1:20*l^2-14*l) = 0;
  backward(10*l+1:20*l+1:20*l^2-9*l) = 0;
  backward(15*l+1:20*l+1:20*l^2-4*l) = 0;

  // membangun keadaan awal
  x0 = zeros(5*l,1);
  x0(2:l) = cumsum(sum([th(1:l-1) tk(1:l-1)],'c'));
  x0(l+1) = th(1);
  // nama place
  np = emptystr(5*l,1);
  np(1:l) = 'M' + string(1:l)';
  np(l+1:4:5*l-3) = 'H' + string(1:l)';
  np(l+2:4:5*l-2) = 'BH' + string(1:l)';
  np(l+3:4:5*l-1) = 'K' + string(1:l)';
  np(l+4:4:5*l) = 'BK' + string(1:l)';

  // nama transisi
  nt = emptystr(4*l,1);
  nt(1:4:4*l-3) = 'hn' + string(1:l)';
  nt(2:4:4*l-2) = 'hk' + string(1:l)';
  nt(3:4:4*l-1) = 'kn' + string(1:l)';
  nt(4:4:4*l) = 'km' + string(1:l)';
endfunction
