function [forward,backward,x0,np,nt] = tlreduced(th,tk)
  // Petri net lampu lalulintas tereduksi

  // menghitung jumlah jalur
  l = length(th);

  // membangun matriks forward incidence
  forward = zeros(l+4,4*l);
  wkt = sum([th tk]) - sum([th tk],'c');
  forward(4*l^2+16*l-4:4*l^2+16*l-3) = [wkt(l);th(1)]
  // iterasi for pertama
  forward(4*l+13:4*l+16:4*l^2+12*l-19) = th(2:l);
  forward(3*l+13:4*l+17:4*l^2+12*l-21) = wkt(1:l-1);
  // iterasi for kedua
  forward(l+1:4*l+16:4*l^2+13*l-15) = 1;
  forward(l+2:4*l+16:4*l^2+13*l-14) = 1;
  forward(3*l+11:4*l+16:4*l^2+15*l-5) = 1;
  forward(3*l+12:4*l+16:4*l^2+15*l-4) = 1;
  forward(2*l+7:4*l+16:4*l^2+14*l-9) = tk;
  // membangun matriks backward incidence
  backward = [ones(l,4*l);zeros(4,4*l)];
  backward(l+1:4*l+16:4*l^2+13*l-15) = 2;
  backward(2*l+5:4*l+16:4*l^2+14*l-11) = 1;
  backward(3*l+11:4*l+16:4*l^2+15*l-5) = 2;
  backward(4*l+15:4*l+16:4*l^2+16*l-1) = 1;
  backward(2*l+6:4*l+16:4*l^2+14*l-10) = th - 1;
  backward(4*l+16:4*l+16:4*l^2+16*l) = tk - 1;
  backward(1:4*l+17:4*l^2+13*l-16) = 0;
  backward(l+5:4*l+17:4*l^2+14*l-12) = 0;
  backward(2*l+9:4*l+17:4*l^2+15*l-8) = 0;
  backward(3*l+13:4*l+17:4*l^2+16*l-4) = 0;

  // membangun keadaan awal
  x0 = zeros(l+4,1);
  x0(2:l) = cumsum(sum([th(1:l-1) tk(1:l-1)],'c'));
  x0(l+1) = th(1);

  // nama place
  np = emptystr(l+4,1);
  np(1:l) = 'M' + string(1:l)';
  np(l+1:l+4) = ['H';'BH';'K';'BK'];

  // nama transisi
  nt = emptystr(4*l,1);
  nt(1:4:4*l-3) = 'hn' + string(1:l)';
  nt(2:4:4*l-2) = 'hk' + string(1:l)';
  nt(3:4:4*l-1) = 'kn' + string(1:l)';
  nt(4:4:4*l) = 'km' + string(1:l)';
endfunction
